]> git.treefish.org Git - backmeupscotty.git/blob - backmeupscotty
1daddb8dbec5f14bb61fc812c63f0a7ab7a4ffed
[backmeupscotty.git] / backmeupscotty
1 #!/bin/bash
2
3 REMOTE_HOST=localhost
4 REMOTE_DIR=/tmp/backmeupscotty/test
5 ARCHIVE_KEEPNBACKUPS=30
6 ARCHIVE_KEEPNDAYS=30
7 BACKUP_RUNEVERYNTHDAY=1
8
9 _ERROR_ENCOUNTERED=0
10 _UPPERME=$(echo $(basename $0) | tr '[:lower:]' '[:upper:]')
11
12 function timestamp {
13     echo $(date +"[%y-%m-%d %H:%M:%S]")
14 }
15
16 function scottyline {
17     echo $(timestamp) $_UPPERME: $@
18 }
19
20 function scottyinfo {
21     if ($_ERROR_ENCOUNTERED -eq 0); then
22         scottyline $@
23     else
24         scottyline $@ >&2
25     fi
26 }
27
28 function scottyerror {
29     scottyline $@ >&2
30     _ERROR_ENCOUNTERED=1
31 }
32
33 function ssh255 {
34     ssh $@
35     sshret=$?
36
37     if [ $sshret -eq 255 ]; then
38         scottyerror "SSH connection failed!"
39         exit 1
40     else
41         return $sshret
42     fi
43 }
44
45 function grepbackups {
46     ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
47 }
48
49 function isIncomplete {
50     if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
51         return 0
52     else
53         return 1
54     fi
55 }
56
57 function isNthDay {
58     if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
59     then
60         return 0
61     else
62         return 1
63     fi  
64 }
65
66 function latestTooOld {
67     for oldbackup in $(grepbackups); do
68         tstamp=$(echo $oldbackup | cut -d'-' -f1)
69         
70         if [ $(( $(date +%s) - $tstamp )) -lt \
71             $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
72         then
73             return 1
74         fi
75     done
76
77     return 0
78 }
79
80 function scottysync {
81     timestamp=$(date +%s)
82
83     scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
84
85     if [ ! -d "$SYNC_SRC" ]; then
86         scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
87         return 1
88     fi
89
90     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
91         scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
92         return 1
93     fi
94
95     dir_current=$REMOTE_DIR/current
96     dir_incomplete=$REMOTE_DIR/incomplete
97     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
98
99     if [ -z $SYNC_EXC ]; then
100         rsync_exclude=""
101     else
102         rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
103     fi
104
105     if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
106         scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
107         ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
108     fi
109
110     if isIncomplete; then
111         scottyerror "Continuing old incomplete backup."
112     fi
113
114     scottyinfo "Starting rsync."
115     rsync -e ssh \
116         -v -aHAX --numeric-ids --delete --delete-excluded \
117         --link-dest=$dir_current \
118         $rsync_exclude \
119         $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
120     
121     if [ $? -eq 0 ]; then
122         scottyinfo "Timestamping completed backup and linking to current backup."
123         ssh255 $REMOTE_HOST \
124             "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
125     else
126         scottyerror "Rsync failed."
127     fi
128
129     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
130         oldestbackup=$(grepbackups | head -1)
131         oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
132
133         if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
134             scottyinfo "Removing old backup $oldestbackup."
135             ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
136         else
137             break
138         fi
139     done
140 }
141
142 function deleteLock {
143     if ! rmdir /var/lock/$(basename $0); then
144         scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
145     fi
146 }
147
148 function cleanup_abort {
149     scottyerror "Caught exit signal! Cleaning up."
150
151     cleanup ABORT
152
153     if [ $(jobs -p) ]; then
154         scottyerror "TERMinating remaining child processes."
155         kill $(jobs -p)
156     fi
157
158     deleteLock
159
160     exit
161 }
162
163 function cleanup {
164     scottyinfo "No cleanup function was defined."
165 }
166
167 function prepare {
168     scottyinfo "No prepare function was defined."
169 }
170
171 function cleanup_normal {
172     cleanup
173     deleteLock
174 }
175
176 function printhelp {
177     cat <<EOF
178 Usage: $(basename $0) [OPTION]...
179
180 Recognized options:
181   -q   Only output errors
182   -n   Run only on nth day
183   -h   Print out this help
184 EOF
185 }
186
187 function backmeupscotty {
188     while getopts "qn:h" opt; do
189         case $opt in
190             q)
191                 exec > /dev/null
192                 ;;
193             n)
194                 BACKUP_RUNEVERYNTHDAY=$OPTARG
195                 ;;
196             h)
197                 printhelp
198                 exit 0
199                 ;;
200         esac
201     done
202     
203     ssh255 $REMOTE_HOST exit
204
205     if latestTooOld; then
206         scottyerror "The latest backup is too old."
207     elif isNthDay; then
208         scottyinfo "This is the nth day."
209     else
210         scottyinfo "No backup has to be done. Exiting."
211         exit 0
212     fi
213
214     scottyinfo "Performing backup."
215
216     trap cleanup_abort EXIT
217
218     prepare
219     scottysync
220
221     trap cleanup_normal EXIT
222
223     exit 0
224 }
225
226 if ! mkdir /var/lock/$(basename $0); then
227     scottyerror "Another instance of $(basename $0) is still running!"
228     exit 1
229 else
230     trap deleteLock EXIT
231 fi